<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: CoapClient Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classCoapClient-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CoapClient Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a5e8009df16efede98c4f750bd21b59e1"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapClient.html#a5e8009df16efede98c4f750bd21b59e1">CoapClient</a> (coap_context_t *context=nullptr)</td></tr>
<tr class="separator:a5e8009df16efede98c4f750bd21b59e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4751a8eb83688c71b56cd1f24b9975a"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapClient.html#af4751a8eb83688c71b56cd1f24b9975a">~CoapClient</a> ()</td></tr>
<tr class="separator:af4751a8eb83688c71b56cd1f24b9975a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6db00b55c5437b1b239f59c5d1e7ae3a"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapClient.html#a6db00b55c5437b1b239f59c5d1e7ae3a">send_message</a> (<a class="el" href="structrequest__t.html">request_t</a> request)</td></tr>
<tr class="separator:a6db00b55c5437b1b239f59c5d1e7ae3a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa0f931079f33fda874caf691fd2c3f3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmessage__t.html">message_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapClient.html#aaa0f931079f33fda874caf691fd2c3f3">send_message_and_wait_response</a> (<a class="el" href="structrequest__t.html">request_t</a> request, int timeout=5)</td></tr>
<tr class="separator:aaa0f931079f33fda874caf691fd2c3f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ab7a5adf34c482801d427851ef846e53c"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="structmessage__t.html">message_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapClient.html#ab7a5adf34c482801d427851ef846e53c">receive_message</a> (std::string token, int timeout=5)</td></tr>
<tr class="separator:ab7a5adf34c482801d427851ef846e53c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a5e8009df16efede98c4f750bd21b59e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e8009df16efede98c4f750bd21b59e1">&#9670;&nbsp;</a></span>CoapClient()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">CoapClient::CoapClient </td>
          <td>(</td>
          <td class="paramtype">coap_context_t *&#160;</td>
          <td class="paramname"><em>context</em> = <code>nullptr</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">explicit</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><a class="el" href="classCoapClient.html">CoapClient</a> constructor that initializes communication context and handlers. The constructor starts a thread that runs the coap I/O processing function. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">context</td><td>A pre-initialized context that is used for CoAP client communication. If context == nullptr, a new context will be created. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af4751a8eb83688c71b56cd1f24b9975a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af4751a8eb83688c71b56cd1f24b9975a">&#9670;&nbsp;</a></span>~CoapClient()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CoapClient::~CoapClient </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><a class="el" href="classCoapClient.html">CoapClient</a> destructor stops client thread and releases resources. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ab7a5adf34c482801d427851ef846e53c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab7a5adf34c482801d427851ef846e53c">&#9670;&nbsp;</a></span>receive_message()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="structmessage__t.html">message_t</a> CoapClient::receive_message </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>token</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>timeout</em> = <code>5</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Receive a response that matches a previously sent request </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">token</td><td>Token of the request previously sent. </td></tr>
    <tr><td class="paramname">timeout</td><td>Maximum amount of time in seconds to wait for a response message that matches the given token. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The response message that matches the request token. If no response is received before timeout, the message will contain a GATEWAY_TIMEOUT status code. </dd></dl>

</div>
</div>
<a id="a6db00b55c5437b1b239f59c5d1e7ae3a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6db00b55c5437b1b239f59c5d1e7ae3a">&#9670;&nbsp;</a></span>send_message()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string CoapClient::send_message </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrequest__t.html">request_t</a>&#160;</td>
          <td class="paramname"><em>request</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Send a coap request. This method is non-blocking and does not wait for the response. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">request</td><td>The request to send. This parameter contains information such as destination and data of the request. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Token of the request that will be used for matching the response. </dd></dl>

</div>
</div>
<a id="aaa0f931079f33fda874caf691fd2c3f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa0f931079f33fda874caf691fd2c3f3">&#9670;&nbsp;</a></span>send_message_and_wait_response()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmessage__t.html">message_t</a> CoapClient::send_message_and_wait_response </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrequest__t.html">request_t</a>&#160;</td>
          <td class="paramname"><em>request</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>timeout</em> = <code>5</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Send a coap request and immediately wait for a response </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">request</td><td>The request to send. This parameter contains information such as destination and data of the request. </td></tr>
    <tr><td class="paramname">timeout</td><td>Maximum amount of time in seconds to wait for a response message that matches the given token. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The response message that matches the request token. If no response is received before timeout, the message will contain a GATEWAY_TIMEOUT status code. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/builds/eclipse/oniro-core/eddie/linux/communication/include/<a class="el" href="CoapClient_8h_source.html">CoapClient.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
